# frozen_string_literal: true

source 'https://rubygems.org'
git_source(:github) { |repo| "https://github.com/#{repo}.git" }

ruby '2.7.6'

# Bundle edge Rails instead: gem 'rails', github: 'rails/rails'
gem 'rails', '~> 6.1'
# Use postgres as the database for Active Record
gem 'pg'
# Use Puma as the app server
gem 'puma', '~> 5.0'
# Use SCSS for stylesheets
gem 'sass-rails', '~> 5', '< 6' # FIXME: seting to >= 6 does not work due to sassc incompatibility
# Transpile app-like JavaScript. Read more: https://github.com/rails/webpacker
gem 'webpacker', '~> 5.0'
# Turbolinks makes navigating your web application faster. Read more: https://github.com/turbolinks/turbolinks
gem 'turbolinks', '~> 5'
# Build JSON APIs with ease. Read more: https://github.com/rails/jbuilder
gem 'jbuilder', '~> 2.7'
# Use Redis adapter to run Action Cable in production
# We will be using it for caching as well
gem 'redis', '~> 4.0'
# High performance redis adapter
gem 'hiredis'
# Use Active Model has_secure_password
# gem 'bcrypt', '~> 3.1.7'

# Use Active Storage variant
# gem 'image_processing', '~> 1.2'

# Reduces boot times through caching; required in config/boot.rb
gem 'bootsnap', '>= 1.4.4', require: false

# User management
gem 'devise'
gem 'devise-i18n'

# Provides translations in several idioms to Rails' default texts
gem 'rails-i18n', '~> 6.0.0'

# Administration interface
gem 'trestle'
gem 'trestle-auth'

# Creation of search forms
gem 'ransack'

# Save searches to session and autoloads them
gem 'ransack_memory'

# Store sessions to the database
gem 'activerecord-session_store'

# Compute statistics such as distance percentiles
gem 'descriptive_statistics', require: 'descriptive_statistics/safe'

# Generate pdf from html views
gem 'wicked_pdf'

group :development, :test do
  # Call 'byebug' anywhere in the code to stop execution and get a debugger console
  gem 'byebug', platforms: %i[mri mingw x64_mingw]
  # Unit test framework
  gem 'rspec-rails', '~> 4.0.0'
  # Test fixtures creation
  gem 'factory_bot_rails'
  # Help to increase the performance reducing the number of queries
  gem 'bullet'
end

group :development do
  # Access an interactive console on exception pages or by calling 'console' anywhere in the code.
  gem 'listen', '~> 3.3'
  gem 'web-console', '>= 4.1.0'
  # Display performance information such as SQL time and flame graphs for each request in your browser.
  # Can be configured to work on production as well see: https://github.com/MiniProfiler/rack-mini-profiler/blob/master/README.md
  gem 'rack-mini-profiler', '~> 2.0'
  # Spring speeds up development by keeping your application running in the background. Read more: https://github.com/rails/spring
  gem 'spring'
  # Check for gem security risks
  gem 'brakeman'
  # Code analyzer
  gem 'rubocop', require: false
  gem 'rubocop-rails'
  # Find code duplications
  gem 'flay', require: false
  # Check dependencies licenses
  gem 'license_finder'
end

group :test do
  # Adds support for Capybara system testing and selenium driver
  gem 'capybara', '>= 3.26'
  gem 'selenium-webdriver'
  # Easy installation and use of web drivers to run system tests with browsers
  gem 'webdrivers'
  # Test coverage report
  gem 'simplecov', require: false
  # Acceptance test framework
  gem 'cucumber-rails', require: false
  # database_cleaner is not required, but highly recommended
  gem 'database_cleaner'
  # Simplify test syntax
  gem 'shoulda-matchers'
end

# Windows does not include zoneinfo files, so bundle the tzinfo-data gem
gem 'tzinfo-data', platforms: %i[mingw mswin x64_mingw jruby]

gem 'rails-controller-testing', '~> 1.0'
